/*
 *  YASS 1.10
 *  Copyright (C) 2004,2005
 *  YASS Team
 *  Laurent Noe, Gregory Kucherov, Mikhail Roytberg, 
 *  Christophe Valmir, Steven Corroy
 *
 *  noe|<A>|lifl.fr
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This software contains code derived from the GNU libavl library.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef __KWORD_H_
#define __KWORD_H_

#include "threads.h"

#define KEY(keyvalue,data,pos,seed) {                           \
    int  _i_ = 0;                                               \
    char _seed_element_ = 0;                                    \
    char _data_element_ = 0;                                    \
    keyvalue = 0;                                               \
    for ( _i_ = 0 ; _i_ < gp_seeds_span[seed] ; _i_++ ){        \
        _seed_element_ = gp_motifs[seed][_i_];                  \
        _data_element_ = data[(pos)+_i_];                       \
        if (_data_element_ == 6 ) _data_element_ = 1;           \
	if (_data_element_ > (char)3) {                         \
	   keyvalue = 0;                                        \
	   break;                                               \
        }                                                       \
        switch (_seed_element_) {                               \
           case '#' :                                           \
	      keyvalue <<= 2;                                   \
	      keyvalue  |= ((int) _data_element_ & 0x3);        \
	   break;                                               \
	   case '@' :                                           \
              keyvalue <<= 1;                                   \
	      keyvalue  |= ((int) _data_element_ & 0x1);        \
           break;                                               \
	}                                                       \
    }                                                           \
}



int CreateData( /*in */ char *filename,
	       /*out */ char **p_data, /*out */ int *p_datasize, /*out */
	       int *p_nbchunks, /*out */ char ***p_chunkname, /*out */
		int **p_chunksize, /*out */ int **p_chunkstart,
		/* out */int nbletters[4]);

int CreateReverseComplement( /*in */ char *data_in,
			    /*out */ int datasize,
			    /*out */ char **p_data_out);

int CreateKeyList( /* in */  char *data,    /* in  */ int   datasize,    /* in */ int seed,
		   /* out */ int **p_first, /* out */ int * p_first_size, 
		   /* out */ int **p_list,  /* out */ int * p_list_size, /* out */ Feature * feature);

int ComputeLength();

void AutomataOverlaps(int delph);

double Entropy(char *data, int pos, int len, int k);


int DisplaySequence(char *data, int pos, int len);

int DisplayData(char * filename, char * data, int size, int nbchunks, char ** chunkname, int * chunksize, int * chunkstrt);

int DisplaySeeds();

#endif
